[arch-commits] Commit in (17 files)

Bruno Pagani archange at gemini.archlinux.org
Wed Jul 6 12:26:55 UTC 2022


    Date: Wednesday, July 6, 2022 @ 12:26:55
  Author: archange
Revision: 1246712

Versionned electron 18.x package

Added:
  electron18/
  electron18/repos/
  electron18/trunk/
  electron18/trunk/PKGBUILD
  electron18/trunk/default_app-icon.patch
  electron18/trunk/electron-launcher.sh
  electron18/trunk/electron.desktop
  electron18/trunk/enable-GlobalMediaControlsCastStartStop.patch
  electron18/trunk/fix-no-member-named-tie-in-namespace-std.patch
  electron18/trunk/iwyu-add-utility-for-std-exchange.patch
  electron18/trunk/iwyu-add-vector-needed-by-statsentry.patch
  electron18/trunk/jinja-python-3.10.patch
  electron18/trunk/sql-make-VirtualCursor-standard-layout-type.patch
  electron18/trunk/std-vector-non-const.patch
  electron18/trunk/use-system-libraries-in-node.patch
  electron18/trunk/webcodecs-stop-using-AudioOpusEncoder.patch
  electron18/trunk/webrtc-check-existence-of-cursor-metadata.patch

---------------------------------------------------+
 PKGBUILD                                          |  293 ++++++++++++++++++++
 default_app-icon.patch                            |   21 +
 electron-launcher.sh                              |   20 +
 electron.desktop                                  |    7 
 enable-GlobalMediaControlsCastStartStop.patch     |   32 ++
 fix-no-member-named-tie-in-namespace-std.patch    |   28 +
 iwyu-add-utility-for-std-exchange.patch           |   27 +
 iwyu-add-vector-needed-by-statsentry.patch        |   29 +
 jinja-python-3.10.patch                           |   22 +
 sql-make-VirtualCursor-standard-layout-type.patch |  238 ++++++++++++++++
 std-vector-non-const.patch                        |  129 ++++++++
 use-system-libraries-in-node.patch                |   53 +++
 webcodecs-stop-using-AudioOpusEncoder.patch       |   49 +++
 webrtc-check-existence-of-cursor-metadata.patch   |   31 ++
 14 files changed, 979 insertions(+)

Added: electron18/trunk/PKGBUILD
===================================================================
--- electron18/trunk/PKGBUILD	                        (rev 0)
+++ electron18/trunk/PKGBUILD	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,293 @@
+# Maintainer: Nicola Squartini <tensor5 at gmail.com>
+
+_use_suffix=1
+pkgver=18.2.4
+_commit=f4ba63536a3558f814a81015ecbfaf3451be5694
+_chromiumver=100.0.4896.160
+_gcc_patchset=4
+# shellcheck disable=SC2034
+pkgrel=1
+
+_major_ver=${pkgver%%.*}
+if [[ ${_use_suffix} != 0 ]]; then
+  pkgname="electron${_major_ver}"
+else
+  pkgname=electron
+fi
+# shellcheck disable=SC2034
+pkgdesc='Build cross platform desktop apps with web technologies'
+# shellcheck disable=SC2034
+arch=('x86_64')
+# shellcheck disable=SC2034
+url='https://electronjs.org/'
+# shellcheck disable=SC2034
+license=('MIT' 'custom')
+# shellcheck disable=SC2034
+depends=('c-ares' 'ffmpeg' 'gtk3' 'libevent' 'libxslt' 'minizip' 'nss' 're2'
+         'snappy')
+# shellcheck disable=SC2034
+makedepends=('clang' 'git' 'gn' 'gperf' 'harfbuzz-icu' 'http-parser'
+             'java-runtime-headless' 'jsoncpp' 'libnotify' 'lld' 'llvm' 'ninja'
+             'npm' 'pciutils' 'pipewire' 'python' 'python-httplib2'
+             'python-pyparsing' 'python-six' 'wget' 'yarn')
+# shellcheck disable=SC2034
+optdepends=('kde-cli-tools: file deletion support (kioclient5)'
+            'libappindicator-gtk3: StatusNotifierItem support'
+            'pipewire: WebRTC desktop sharing under Wayland'
+            'trash-cli: file deletion support (trash-put)'
+            "xdg-utils: open URLs with desktop's default (xdg-email, xdg-open)")
+if [[ ${_use_suffix} == 0 ]]; then
+  # shellcheck disable=SC2034
+  conflicts=("electron${_major_ver}")
+  # shellcheck disable=SC2034
+  provides=("electron${_major_ver}")
+fi
+# shellcheck disable=SC2034
+options=('!lto') # Electron adds its own flags for ThinLTO
+# shellcheck disable=SC2034
+source=('git+https://github.com/electron/electron.git'
+        'git+https://chromium.googlesource.com/chromium/tools/depot_tools.git#branch=main'
+        "https://github.com/stha09/chromium-patches/releases/download/chromium-${_chromiumver%%.*}-patchset-${_gcc_patchset}/chromium-${_chromiumver%%.*}-patchset-${_gcc_patchset}.tar.xz"
+        "electron-launcher.sh"
+        "electron.desktop"
+        'default_app-icon.patch'
+        'jinja-python-3.10.patch'
+        'std-vector-non-const.patch'
+        'use-system-libraries-in-node.patch'
+        'webcodecs-stop-using-AudioOpusEncoder.patch'
+        'webrtc-check-existence-of-cursor-metadata.patch'
+        'fix-no-member-named-tie-in-namespace-std.patch'
+        'iwyu-add-utility-for-std-exchange.patch'
+        'iwyu-add-vector-needed-by-statsentry.patch'
+        'enable-GlobalMediaControlsCastStartStop.patch'
+        'sql-make-VirtualCursor-standard-layout-type.patch'
+       )
+# shellcheck disable=SC2034
+sha256sums=('SKIP'
+            'SKIP'
+            'a6120e7d4eb5e131b87b6ab3b922e0c6cd78e15501e54cfb2019875173688d80'
+            '3953f532a3ea5fce19ee33600c6ead89dcd066df6a01d3c3ab4c24f96e46fca2'
+            '4484200d90b76830b69eea3a471c103999a3ce86bb2c29e6c14c945bf4102bae'
+            'dd2d248831dd4944d385ebf008426e66efe61d6fdf66f8932c963a12167947b4'
+            '55dbe71dbc1f3ab60bf1fa79f7aea7ef1fe76436b1d7df48728a1f8227d2134e'
+            '880abb38ea94058ad553eaec9989cb33aa3b10c54b44afcfddacef3e975152de'
+            'c70652a8b24c237bcfd27469de32797a2cb46d9f0d63d897bb6418314a25644c'
+            '064daaa2b9d95b96ec04d8ddebf4af441f92263d123365b58fe73966866080af'
+            '88b2c8d9c6c1917f6632453f18aad7a3fd94d605eecb6c77ae2394ac5856ba95'
+            '7ad0106161bbf25e2e603ae1a723ae4217155ebb26eb4778363ad396e8c14156'
+            '6f666ef0acb08704ca58cc0d5e97e7ce64d8fea51042e593adae1ce15a61231c'
+            '0ec88c8022c946ac333cbc1060d6b9cacbef6c4a86fe8763d23add6939a3c490'
+            '779fb13f2494209d3a7f1f23a823e59b9dded601866d3ab095937a1a04e19ac6'
+            'b94b2e88f63cfb7087486508b8139599c89f96d7a4181c61fec4b4e250ca327a'
+           )
+
+_system_libs=('ffmpeg'
+              'flac'
+              'fontconfig'
+              'freetype'
+              'harfbuzz-ng'
+              'icu'
+              'libdrm'
+              'libevent'
+              'libjpeg'
+              'libpng'
+#              'libvpx'
+              'libwebp'
+              'libxml'
+              'libxslt'
+#              'openh264'
+              'opus'
+              're2'
+              'snappy'
+              'zlib'
+             )
+
+prepare() {
+  sed -i "s|@ELECTRON@|${pkgname}|" electron-launcher.sh
+  sed -i "s|@ELECTRON@|${pkgname}|" electron.desktop
+  if [[ ${_use_suffix} != 0 ]]; then
+    sed -i "s|@ELECTRON_NAME@|Electron ${_major_ver}|" electron.desktop
+  else
+    sed -i "s|@ELECTRON_NAME@|Electron|" electron.desktop
+  fi
+
+  export PATH="${PATH}:${srcdir:?}/depot_tools"
+
+  echo "Fetching chromium..."
+  git clone --branch=${_chromiumver} --depth=1 \
+      https://chromium.googlesource.com/chromium/src.git
+
+  echo "solutions = [
+  {
+    \"name\": \"src/electron\",
+    \"url\": \"file://${srcdir}/electron@${_commit}\",
+    \"deps_file\": \"DEPS\",
+    \"managed\": False,
+    \"custom_deps\": {
+      \"src\": None,
+    },
+    \"custom_vars\": {},
+  },
+]" > .gclient
+
+  python "${srcdir}/depot_tools/gclient.py" sync \
+      --with_branch_heads \
+      --with_tags \
+      --nohooks
+
+  (
+    cd src/electron || exit
+    patch -Np1 -i ../../std-vector-non-const.patch
+  )
+
+  echo "Running hooks..."
+  # python "${srcdir}/depot_tools/gclient.py" runhooks
+  src/build/landmines.py
+  src/build/util/lastchange.py -o src/build/util/LASTCHANGE
+  src/build/util/lastchange.py -m GPU_LISTS_VERSION \
+    --revision-id-only --header src/gpu/config/gpu_lists_version.h
+  src/build/util/lastchange.py -m SKIA_COMMIT_HASH \
+    -s src/third_party/skia --header src/skia/ext/skia_commit_hash.h
+  # Create sysmlink to system clang-format
+  ln -s /usr/bin/clang-format src/buildtools/linux64
+  # Create sysmlink to system Node.js
+  mkdir -p src/third_party/node/linux/node-linux-x64/bin
+  ln -sf /usr/bin/node src/third_party/node/linux/node-linux-x64/bin
+  src/third_party/depot_tools/download_from_google_storage.py \
+    --no_resume --extract --no_auth --bucket chromium-nodejs \
+    -s src/third_party/node/node_modules.tar.gz.sha1
+  python src/tools/download_optimization_profile.py \
+    --newest_state=src/chrome/android/profiles/newest.txt \
+    --local_state=src/chrome/android/profiles/local.txt \
+    --output_name=src/chrome/android/profiles/afdo.prof \
+    --gs_url_base=chromeos-prebuilt/afdo-job/llvm
+  #vpython src/tools/update_pgo_profiles.py \
+  #  --target=linux \
+  #  update \
+  #  --gs-url-base=chromium-optimization-profiles/pgo_profiles
+  src/electron/script/apply_all_patches.py \
+      src/electron/patches/config.json
+  cd src/electron || exit
+  yarn install --frozen-lockfile
+  cd ..
+
+  echo "Applying local patches..."
+  # Upstream fixes
+  patch -Np1 -i ../webcodecs-stop-using-AudioOpusEncoder.patch
+  patch -Np1 -d third_party/webrtc <../webrtc-check-existence-of-cursor-metadata.patch
+
+  # Upstream fixes
+  patch -Np1 -i ../fix-no-member-named-tie-in-namespace-std.patch
+  patch -Np1 -i ../iwyu-add-utility-for-std-exchange.patch
+  patch -Np1 -i ../iwyu-add-vector-needed-by-statsentry.patch
+
+  # Revert kGlobalMediaControlsCastStartStop enabled by default
+  # https://crbug.com/1314342
+  patch -Rp1 -F3 -i ../enable-GlobalMediaControlsCastStartStop.patch
+
+  # https://chromium-review.googlesource.com/c/chromium/src/+/2862724
+  patch -Np1 -i ../sql-make-VirtualCursor-standard-layout-type.patch
+
+  # Fixes for building with libstdc++ instead of libc++
+  #patch -Np1 -i ../patches/
+
+  # Electron specific fixes
+  patch -d third_party/electron_node/tools/inspector_protocol/jinja2 \
+      -Np1 -i ../../../../../../jinja-python-3.10.patch
+  patch -Np1 -i ../use-system-libraries-in-node.patch
+  patch -Np1 -i ../default_app-icon.patch  # Icon from .desktop file
+
+  echo "Patching Chromium for using system libraries..."
+  sed -i 's/OFFICIAL_BUILD/GOOGLE_CHROME_BUILD/' \
+      tools/generate_shim_headers/generate_shim_headers.py
+  for lib in $(printf "%s\n" "${_system_libs[@]}" | sed 's/^libjpeg$/&_turbo/'); do
+      third_party_dir="third_party/${lib}"
+      if [ ! -d "${third_party_dir}" ]; then
+        third_party_dir="base/${third_party_dir}"
+      fi
+      find "${third_party_dir}" -type f \
+          \! -path "${third_party_dir}/chromium/*" \
+          \! -path "${third_party_dir}/google/*" \
+          \! -path 'third_party/harfbuzz-ng/utils/hb_scoped.h' \
+          \! -regex '.*\.\(gn\|gni\|isolate\)' \
+          -delete
+  done
+  build/linux/unbundle/replace_gn_files.py \
+      --system-libraries \
+      "${_system_libs[@]}"
+}
+
+build() {
+  export CC=clang
+  export CXX=clang++
+  export AR=ar
+  export NM=nm
+
+  CFLAGS="${CFLAGS/-fexceptions/}"
+  CXXFLAGS="${CXXFLAGS/-fexceptions/}"
+
+  # This appears to cause random segfaults when combined with ThinLTO
+  # https://bugs.archlinux.org/task/73518
+  CFLAGS=${CFLAGS/-fstack-clash-protection}
+  CXXFLAGS=${CXXFLAGS/-fstack-clash-protection}
+
+  # https://crbug.com/957519#c122
+  CXXFLAGS=${CXXFLAGS/-Wp,-D_GLIBCXX_ASSERTIONS}
+
+  # Do not warn about unknown warning options
+  CFLAGS+='   -Wno-unknown-warning-option'
+  CXXFLAGS+=' -Wno-unknown-warning-option'
+
+  cd src || exit
+  export CHROMIUM_BUILDTOOLS_PATH="${PWD}/buildtools"
+  GN_EXTRA_ARGS='
+    blink_symbol_level = 0
+    chrome_pgo_phase = 0
+    clang_use_chrome_plugins = false
+    custom_toolchain = "//build/toolchain/linux/unbundle:default"
+    host_toolchain = "//build/toolchain/linux/unbundle:default"
+    icu_use_data_file = false
+    is_component_ffmpeg = false
+    link_pulseaudio = true
+    rtc_use_pipewire = true
+    treat_warnings_as_errors = false
+    use_custom_libcxx = false
+    use_gnome_keyring = false
+    use_sysroot = false
+  '
+  gn gen out/Release \
+      --args="import(\"//electron/build/args/release.gn\") ${GN_EXTRA_ARGS}"
+  ninja -C out/Release electron
+  # Strip before zip to avoid
+  # zipfile.LargeZipFile: Filesize would require ZIP64 extensions
+  strip -s out/Release/electron
+  ninja -C out/Release electron_dist_zip
+  # ninja -C out/Release third_party/electron_node:headers
+}
+
+package() {
+  install -dm755 "${pkgdir:?}/usr/lib/${pkgname}"
+  bsdtar -xf src/out/Release/dist.zip -C "${pkgdir}/usr/lib/${pkgname}"
+
+  chmod u+s "${pkgdir}/usr/lib/${pkgname}/chrome-sandbox"
+
+  install -dm755 "${pkgdir}/usr/share/licenses/${pkgname}"
+  for l in "${pkgdir}/usr/lib/${pkgname}"/{LICENSE,LICENSES.chromium.html}; do
+    ln -s  \
+      "$(realpath --relative-to="${pkgdir}/usr/share/licenses/${pkgname}" "${l}")" \
+      "${pkgdir}/usr/share/licenses/${pkgname}"
+  done
+
+  install -Dm755 "${srcdir}/electron-launcher.sh" \
+    "${pkgdir}/usr/bin/${pkgname}"
+  if [[ "${_use_suffix}" == 0 ]]; then
+    ln "${pkgdir}/usr/bin/${pkgname}" \
+      "${pkgdir}/usr/bin/${pkgname}${_major_ver}"
+  fi
+
+  # Install .desktop and icon file (see default_app-icon.patch)
+  install -Dm644 electron.desktop \
+    "${pkgdir}/usr/share/applications/${pkgname}.desktop"
+  install -Dm644 src/electron/default_app/icon.png \
+          "${pkgdir}/usr/share/pixmaps/${pkgname}.png"  # hicolor has no 1024x1024
+}

Added: electron18/trunk/default_app-icon.patch
===================================================================
--- electron18/trunk/default_app-icon.patch	                        (rev 0)
+++ electron18/trunk/default_app-icon.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,21 @@
+--- a/electron/default_app/default_app.ts
++++ b/electron/default_app/default_app.ts
+@@ -60,7 +60,7 @@
+   };
+ 
+   if (process.platform === 'linux') {
+-    options.icon = path.join(__dirname, 'icon.png');
++    options.icon = '/usr/share/pixmaps/electron.png';
+   }
+ 
+   mainWindow = new BrowserWindow(options);
+--- a/electron/filenames.gni
++++ b/electron/filenames.gni
+@@ -6,7 +6,6 @@
+   ]
+ 
+   default_app_static_sources = [
+-    "default_app/icon.png",
+     "default_app/index.html",
+     "default_app/package.json",
+     "default_app/styles.css",

Added: electron18/trunk/electron-launcher.sh
===================================================================
--- electron18/trunk/electron-launcher.sh	                        (rev 0)
+++ electron18/trunk/electron-launcher.sh	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,20 @@
+#!/usr/bin/bash
+
+set -euo pipefail
+
+name=@ELECTRON@
+flags_file="${XDG_CONFIG_HOME:-$HOME/.config}/${name}-flags.conf"
+
+declare -a flags
+
+if [[ -f "${flags_file}" ]]; then
+    mapfile -t < "${flags_file}"
+fi
+
+for line in "${MAPFILE[@]}"; do
+    if [[ ! "${line}" =~ ^[[:space:]]*#.* ]]; then
+        flags+=("${line}")
+    fi
+done
+
+exec /usr/lib/${name}/electron "$@" "${flags[@]}"

Added: electron18/trunk/electron.desktop
===================================================================
--- electron18/trunk/electron.desktop	                        (rev 0)
+++ electron18/trunk/electron.desktop	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,7 @@
+[Desktop Entry]
+Type=Application
+Name=@ELECTRON_NAME@
+Icon=@ELECTRON@
+Exec=@ELECTRON@ %u
+Categories=Development;GTK;
+StartupNotify=true

Added: electron18/trunk/enable-GlobalMediaControlsCastStartStop.patch
===================================================================
--- electron18/trunk/enable-GlobalMediaControlsCastStartStop.patch	                        (rev 0)
+++ electron18/trunk/enable-GlobalMediaControlsCastStartStop.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,32 @@
+From b58f0f2725a8c1a8a131f9984b5fd53b54119dba Mon Sep 17 00:00:00 2001
+From: Muyao Xu <muyaoxu at google.com>
+Date: Thu, 20 Jan 2022 23:46:21 +0000
+Subject: [PATCH] [Zenith] Enable GlobalMediaControlsCastStartStop flag by
+ default
+
+The feature is rolled out to 100% stable through finch for M96+.
+This CL enables it by default and fixes some unit tests failures.
+
+Bug: 1287242, 1287305
+Change-Id: I7e5c9625b77379fef253c41ef292a0dd6fc366fb
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3388416
+Reviewed-by: Takumi Fujimoto <takumif at chromium.org>
+Commit-Queue: Muyao Xu <muyaoxu at google.com>
+Cr-Commit-Position: refs/heads/main@{#961658}
+---
+ chrome/browser/media/router/media_router_feature.cc | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/chrome/browser/media/router/media_router_feature.cc b/chrome/browser/media/router/media_router_feature.cc
+index f28f9b0b802..a8d544f7d6d 100644
+--- a/chrome/browser/media/router/media_router_feature.cc
++++ b/chrome/browser/media/router/media_router_feature.cc
+@@ -33,7 +33,7 @@ const base::Feature kMediaRouter{"MediaRouter",
+ const base::Feature kCastAllowAllIPsFeature{"CastAllowAllIPs",
+                                             base::FEATURE_DISABLED_BY_DEFAULT};
+ const base::Feature kGlobalMediaControlsCastStartStop{
+-    "GlobalMediaControlsCastStartStop", base::FEATURE_DISABLED_BY_DEFAULT};
++    "GlobalMediaControlsCastStartStop", base::FEATURE_ENABLED_BY_DEFAULT};
+ const base::Feature kAllowAllSitesToInitiateMirroring{
+     "AllowAllSitesToInitiateMirroring", base::FEATURE_DISABLED_BY_DEFAULT};
+ const base::Feature kDialMediaRouteProvider{"DialMediaRouteProvider",

Added: electron18/trunk/fix-no-member-named-tie-in-namespace-std.patch
===================================================================
--- electron18/trunk/fix-no-member-named-tie-in-namespace-std.patch	                        (rev 0)
+++ electron18/trunk/fix-no-member-named-tie-in-namespace-std.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,28 @@
+From 68c9c63c0b148ff5246a0cdad59000697bbd8645 Mon Sep 17 00:00:00 2001
+From: Maksim Sisov <msisov at igalia.com>
+Date: Tue, 12 Apr 2022 15:11:34 +0000
+Subject: [PATCH] Fix no member named 'tie' in namespace 'std'
+
+Bug: None
+Change-Id: I8a097af2b16b738fa9bbb8231536bca85522f350
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3581869
+Auto-Submit: Maksim Sisov <msisov at igalia.com>
+Reviewed-by: Matt Menke <mmenke at chromium.org>
+Commit-Queue: Matt Menke <mmenke at chromium.org>
+Cr-Commit-Position: refs/heads/main@{#991529}
+---
+ net/base/address_list.h | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/net/base/address_list.h b/net/base/address_list.h
+index 029af1aded3..a93093e41f3 100644
+--- a/net/base/address_list.h
++++ b/net/base/address_list.h
+@@ -8,6 +8,7 @@
+ #include <stdint.h>
+ 
+ #include <string>
++#include <tuple>
+ #include <utility>
+ #include <vector>
+ 

Added: electron18/trunk/iwyu-add-utility-for-std-exchange.patch
===================================================================
--- electron18/trunk/iwyu-add-utility-for-std-exchange.patch	                        (rev 0)
+++ electron18/trunk/iwyu-add-utility-for-std-exchange.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,27 @@
+From 9dd0503835dc875807ab63efb1f477bffed2a852 Mon Sep 17 00:00:00 2001
+From: Stephan Hartmann <stha09 at googlemail.com>
+Date: Mon, 25 Apr 2022 23:18:30 +0000
+Subject: [PATCH] IWYU: add utility for std::exchange
+
+Bug: 957519
+Change-Id: I307d520fdc34d2452018ed32a505e7e519739410
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3604643
+Reviewed-by: Wez <wez at chromium.org>
+Commit-Queue: Stephan Hartmann <stha09 at googlemail.com>
+Cr-Commit-Position: refs/heads/main@{#995855}
+---
+ base/third_party/symbolize/symbolize.h | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/base/third_party/symbolize/symbolize.h b/base/third_party/symbolize/symbolize.h
+index 99029a968d5..278078f6071 100644
+--- a/base/third_party/symbolize/symbolize.h
++++ b/base/third_party/symbolize/symbolize.h
+@@ -61,6 +61,7 @@
+ #ifdef HAVE_SYMBOLIZE
+ 
+ #include <algorithm>
++#include <utility>
+ 
+ #if defined(__ELF__)  // defined by gcc
+ #if defined(__OpenBSD__)

Added: electron18/trunk/iwyu-add-vector-needed-by-statsentry.patch
===================================================================
--- electron18/trunk/iwyu-add-vector-needed-by-statsentry.patch	                        (rev 0)
+++ electron18/trunk/iwyu-add-vector-needed-by-statsentry.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,29 @@
+From 72b521be7640a1b06adf6881b12277276ab8609d Mon Sep 17 00:00:00 2001
+From: Piotr Tworek <ptworek at vewd.com>
+Date: Wed, 06 Apr 2022 19:34:29 +0000
+Subject: [PATCH] IWYU: Add vector needed by StatsEntry.
+
+This builds fine with libc++, but fails due to std::vector being
+undefined when using libstdc++. Add missing vector include to fix this.
+
+Bug: 957519
+Change-Id: I12f91636fe9c69046ae36528e48782acf741b66c
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3557455
+Auto-Submit: Piotr Tworek <ptworek at vewd.com>
+Reviewed-by: Chrome Cunningham <chcunningham at chromium.org>
+Commit-Queue: Chrome Cunningham <chcunningham at chromium.org>
+Cr-Commit-Position: refs/heads/main@{#989578}
+---
+
+diff --git a/media/capabilities/webrtc_video_stats_db.h b/media/capabilities/webrtc_video_stats_db.h
+index 8a5c0cf..0e8653b 100644
+--- a/media/capabilities/webrtc_video_stats_db.h
++++ b/media/capabilities/webrtc_video_stats_db.h
+@@ -7,6 +7,7 @@
+ 
+ #include <memory>
+ #include <string>
++#include <vector>
+ 
+ #include "base/callback_forward.h"
+ #include "base/check.h"

Added: electron18/trunk/jinja-python-3.10.patch
===================================================================
--- electron18/trunk/jinja-python-3.10.patch	                        (rev 0)
+++ electron18/trunk/jinja-python-3.10.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,22 @@
+--- a/runtime.py
++++ b/runtime.py
+@@ -315,7 +315,7 @@ class Context(with_metaclass(ContextMeta
+ 
+ # register the context as mapping if possible
+ try:
+-    from collections import Mapping
++    from collections.abc import Mapping
+     Mapping.register(Context)
+ except ImportError:
+     pass
+--- a/sandbox.py
++++ b/sandbox.py
+@@ -14,7 +14,7 @@
+ """
+ import types
+ import operator
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.environment import Environment
+ from jinja2.exceptions import SecurityError
+ from jinja2._compat import string_types, PY2

Added: electron18/trunk/sql-make-VirtualCursor-standard-layout-type.patch
===================================================================
--- electron18/trunk/sql-make-VirtualCursor-standard-layout-type.patch	                        (rev 0)
+++ electron18/trunk/sql-make-VirtualCursor-standard-layout-type.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,238 @@
+From 144479ad7b4287bee4067f95e4218f614798a865 Mon Sep 17 00:00:00 2001
+From: Stephan Hartmann <stha09 at googlemail.com>
+Date: Sun, 16 Jan 2022 19:15:26 +0000
+Subject: [PATCH] sql: make VirtualCursor standard layout type
+
+sql::recover::VirtualCursor needs to be a standard layout type, but
+has members of type std::unique_ptr. However, std::unique_ptr is not
+guaranteed to be standard layout. Compiling with clang combined with
+gcc-11 libstdc++ fails because of this.
+
+Bug: 1189788
+Change-Id: Ia6dc388cc5ef1c0f2afc75f8ca45b9f12687ca9c
+---
+ sql/recover_module/btree.cc  | 18 ++++++++++++------
+ sql/recover_module/btree.h   | 21 +++++++++++++++------
+ sql/recover_module/cursor.cc | 24 ++++++++++++------------
+ sql/recover_module/cursor.h  |  2 +-
+ sql/recover_module/pager.cc  |  5 ++---
+ sql/recover_module/pager.h   |  6 +++---
+ 6 files changed, 45 insertions(+), 31 deletions(-)
+
+diff --git a/sql/recover_module/btree.cc b/sql/recover_module/btree.cc
+index cc9420e5c05..f12d8fa32a2 100644
+--- a/sql/recover_module/btree.cc
++++ b/sql/recover_module/btree.cc
+@@ -136,16 +136,22 @@ static_assert(std::is_trivially_destructible<LeafPageDecoder>::value,
+               "Move the destructor to the .cc file if it's non-trival");
+ #endif  // !DCHECK_IS_ON()
+ 
+-LeafPageDecoder::LeafPageDecoder(DatabasePageReader* db_reader) noexcept
+-    : page_id_(db_reader->page_id()),
+-      db_reader_(db_reader),
+-      cell_count_(ComputeCellCount(db_reader)),
+-      next_read_index_(0),
+-      last_record_size_(0) {
++LeafPageDecoder::LeafPageDecoder() noexcept = default;
++
++void LeafPageDecoder::Initialize(DatabasePageReader* db_reader) {
++  page_id_ = db_reader->page_id();
++  db_reader_ = db_reader;
++  cell_count_ = ComputeCellCount(db_reader);
++  next_read_index_ = 0;
++  last_record_size_ = 0;
+   DCHECK(IsOnValidPage(db_reader));
+   DCHECK(DatabasePageReader::IsValidPageId(page_id_));
+ }
+ 
++void LeafPageDecoder::Reset() {
++  db_reader_ = nullptr;
++}
++
+ bool LeafPageDecoder::TryAdvance() {
+   DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+   DCHECK(CanAdvance());
+diff --git a/sql/recover_module/btree.h b/sql/recover_module/btree.h
+index eaa087a5c52..df0e0c937c0 100644
+--- a/sql/recover_module/btree.h
++++ b/sql/recover_module/btree.h
+@@ -101,9 +101,7 @@ class LeafPageDecoder {
+  public:
+   // Creates a decoder for a DatabasePageReader's last read page.
+   //
+-  // |db_reader| must have been used to read an inner page of a table B-tree.
+-  // |db_reader| must outlive this instance.
+-  explicit LeafPageDecoder(DatabasePageReader* db_reader) noexcept;
++  LeafPageDecoder() noexcept;
+   ~LeafPageDecoder() noexcept = default;
+ 
+   LeafPageDecoder(const LeafPageDecoder&) = delete;
+@@ -151,6 +149,17 @@ class LeafPageDecoder {
+   // read as long as CanAdvance() returns true.
+   bool TryAdvance();
+ 
++  // Initialize with DatabasePageReader
++  // |db_reader| must have been used to read an inner page of a table B-tree.
++  // |db_reader| must outlive this instance.
++  void Initialize(DatabasePageReader* db_reader);
++
++  // Reset internal DatabasePageReader
++  void Reset();
++
++  // True if DatabasePageReader is valid
++  bool IsValid() { return (db_reader_ != nullptr); }
++
+   // True if the given reader may point to an inner page in a table B-tree.
+   //
+   // The last ReadPage() call on |db_reader| must have succeeded.
+@@ -164,14 +173,14 @@ class LeafPageDecoder {
+   static int ComputeCellCount(DatabasePageReader* db_reader);
+ 
+   // The number of the B-tree page this reader is reading.
+-  const int64_t page_id_;
++  int64_t page_id_;
+   // Used to read the tree page.
+   //
+   // Raw pointer usage is acceptable because this instance's owner is expected
+   // to ensure that the DatabasePageReader outlives this.
+-  DatabasePageReader* const db_reader_;
++  DatabasePageReader* db_reader_;
+   // Caches the ComputeCellCount() value for this reader's page.
+-  const int cell_count_ = ComputeCellCount(db_reader_);
++  int cell_count_;
+ 
+   // The reader's cursor state.
+   //
+diff --git a/sql/recover_module/cursor.cc b/sql/recover_module/cursor.cc
+index 4f827edf1b4..240de4999fe 100644
+--- a/sql/recover_module/cursor.cc
++++ b/sql/recover_module/cursor.cc
+@@ -28,7 +28,7 @@ VirtualCursor::~VirtualCursor() {
+ int VirtualCursor::First() {
+   DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+   inner_decoders_.clear();
+-  leaf_decoder_ = nullptr;
++  leaf_decoder_.Reset();
+ 
+   AppendPageDecoder(table_->root_page_id());
+   return Next();
+@@ -38,18 +38,18 @@ int VirtualCursor::Next() {
+   DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+   record_reader_.Reset();
+ 
+-  while (!inner_decoders_.empty() || leaf_decoder_.get()) {
+-    if (leaf_decoder_.get()) {
+-      if (!leaf_decoder_->CanAdvance()) {
++  while (!inner_decoders_.empty() || leaf_decoder_.IsValid()) {
++    if (leaf_decoder_.IsValid()) {
++      if (!leaf_decoder_.CanAdvance()) {
+         // The leaf has been exhausted. Remove it from the DFS stack.
+-        leaf_decoder_ = nullptr;
++        leaf_decoder_.Reset();
+         continue;
+       }
+-      if (!leaf_decoder_->TryAdvance())
++      if (!leaf_decoder_.TryAdvance())
+         continue;
+ 
+-      if (!payload_reader_.Initialize(leaf_decoder_->last_record_size(),
+-                                      leaf_decoder_->last_record_offset())) {
++      if (!payload_reader_.Initialize(leaf_decoder_.last_record_size(),
++                                      leaf_decoder_.last_record_offset())) {
+         continue;
+       }
+       if (!record_reader_.Initialize())
+@@ -101,13 +101,13 @@ int VirtualCursor::ReadColumn(int column_index,
+ int64_t VirtualCursor::RowId() {
+   DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+   DCHECK(record_reader_.IsInitialized());
+-  DCHECK(leaf_decoder_.get());
+-  return leaf_decoder_->last_record_rowid();
++  DCHECK(leaf_decoder_.IsValid());
++  return leaf_decoder_.last_record_rowid();
+ }
+ 
+ void VirtualCursor::AppendPageDecoder(int page_id) {
+   DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+-  DCHECK(leaf_decoder_.get() == nullptr)
++  DCHECK(!leaf_decoder_.IsValid())
+       << __func__
+       << " must only be called when the current path has no leaf decoder";
+ 
+@@ -115,7 +115,7 @@ void VirtualCursor::AppendPageDecoder(int page_id) {
+     return;
+ 
+   if (LeafPageDecoder::IsOnValidPage(&db_reader_)) {
+-    leaf_decoder_ = std::make_unique<LeafPageDecoder>(&db_reader_);
++    leaf_decoder_.Initialize(&db_reader_);
+     return;
+   }
+ 
+diff --git a/sql/recover_module/cursor.h b/sql/recover_module/cursor.h
+index 845b7852648..cc4e85f83f9 100644
+--- a/sql/recover_module/cursor.h
++++ b/sql/recover_module/cursor.h
+@@ -130,7 +130,7 @@ class VirtualCursor {
+   std::vector<std::unique_ptr<InnerPageDecoder>> inner_decoders_;
+ 
+   // Decodes the leaf page containing records.
+-  std::unique_ptr<LeafPageDecoder> leaf_decoder_;
++  LeafPageDecoder leaf_decoder_;
+ 
+   SEQUENCE_CHECKER(sequence_checker_);
+ };
+diff --git a/sql/recover_module/pager.cc b/sql/recover_module/pager.cc
+index 58e75de2704..69d98cef98d 100644
+--- a/sql/recover_module/pager.cc
++++ b/sql/recover_module/pager.cc
+@@ -23,8 +23,7 @@ static_assert(DatabasePageReader::kMaxPageId <= std::numeric_limits<int>::max(),
+               "ints are not appropriate for representing page IDs");
+ 
+ DatabasePageReader::DatabasePageReader(VirtualTable* table)
+-    : page_data_(std::make_unique<uint8_t[]>(table->page_size())),
+-      table_(table) {
++    : page_data_(table->page_size()), table_(table) {
+   DCHECK(table != nullptr);
+   DCHECK(IsValidPageSize(table->page_size()));
+ }
+@@ -58,7 +57,7 @@ int DatabasePageReader::ReadPage(int page_id) {
+                 "The |read_offset| computation above may overflow");
+ 
+   int sqlite_status =
+-      RawRead(sqlite_file, read_size, read_offset, page_data_.get());
++      RawRead(sqlite_file, read_size, read_offset, page_data_.data());
+ 
+   // |page_id_| needs to be set to kInvalidPageId if the read failed.
+   // Otherwise, future ReadPage() calls with the previous |page_id_| value
+diff --git a/sql/recover_module/pager.h b/sql/recover_module/pager.h
+index 07cac3cb989..d08f0932fab 100644
+--- a/sql/recover_module/pager.h
++++ b/sql/recover_module/pager.h
+@@ -6,8 +6,8 @@
+ #define SQL_RECOVER_MODULE_PAGER_H_
+ 
+ #include <cstdint>
+-#include <memory>
+ #include <ostream>
++#include <vector>
+ 
+ #include "base/check_op.h"
+ #include "base/memory/raw_ptr.h"
+@@ -72,7 +72,7 @@ class DatabasePageReader {
+     DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+     DCHECK_NE(page_id_, kInvalidPageId)
+         << "Successful ReadPage() required before accessing pager state";
+-    return page_data_.get();
++    return page_data_.data();
+   }
+ 
+   // The number of bytes in the page read by the last ReadPage() call.
+@@ -139,7 +139,7 @@ class DatabasePageReader {
+   int page_id_ = kInvalidPageId;
+   // Stores the bytes of the last page successfully read by ReadPage().
+   // The content is undefined if the last call to ReadPage() did not succeed.
+-  const std::unique_ptr<uint8_t[]> page_data_;
++  std::vector<uint8_t> page_data_;
+   // Raw pointer usage is acceptable because this instance's owner is expected
+   // to ensure that the VirtualTable outlives this.
+   const raw_ptr<VirtualTable> table_;

Added: electron18/trunk/std-vector-non-const.patch
===================================================================
--- electron18/trunk/std-vector-non-const.patch	                        (rev 0)
+++ electron18/trunk/std-vector-non-const.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,129 @@
+--- a/patches/chromium/feat_add_data_transfer_to_requestsingleinstancelock.patch
++++ b/patches/chromium/feat_add_data_transfer_to_requestsingleinstancelock.patch
+@@ -46,7 +46,7 @@
+        base::RepeatingCallback<bool(const base::CommandLine& command_line,
+ -                                   const base::FilePath& current_directory)>;
+ +                                   const base::FilePath& current_directory,
+-+                                   const std::vector<const uint8_t> additional_data,
+++                                   const std::vector<uint8_t> additional_data,
+ +                                   const NotificationAckCallback& ack_callback)>;
+  
+  #if BUILDFLAG(IS_WIN)
+@@ -112,7 +112,7 @@
+    // |reader| is for sending back ACK message.
+    void HandleMessage(const std::string& current_dir,
+                       const std::vector<std::string>& argv,
+-+                     const std::vector<const uint8_t> additional_data,
+++                     const std::vector<uint8_t> additional_data,
+                       SocketReader* reader);
+  
+   private:
+@@ -133,7 +133,7 @@
+ -    const std::string& current_dir, const std::vector<std::string>& argv,
+ +    const std::string& current_dir,
+ +    const std::vector<std::string>& argv,
+-+    const std::vector<const uint8_t> additional_data,
+++    const std::vector<uint8_t> additional_data,
+      SocketReader* reader) {
+    DCHECK(ui_task_runner_->BelongsToCurrentThread());
+    DCHECK(reader);
+@@ -195,7 +195,7 @@
+ +  base::StringToSizeT(tokens[0], &num_args);
+ +  std::vector<std::string> command_line(tokens.begin() + 1, tokens.begin() + 1 + num_args);
+ +
+-+  std::vector<const uint8_t> additional_data;
+++  std::vector<uint8_t> additional_data;
+ +  if (tokens.size() >= 3 + num_args) {
+ +    size_t additional_data_size;
+ +    base::StringToSizeT(tokens[1 + num_args], &additional_data_size);
+@@ -204,7 +204,7 @@
+ +        std::string(1, kTokenDelimiter));
+ +    const uint8_t* additional_data_bits =
+ +        reinterpret_cast<const uint8_t*>(remaining_args.c_str());
+-+    additional_data = std::vector<const uint8_t>(additional_data_bits,
+++    additional_data = std::vector<uint8_t>(additional_data_bits,
+ +        additional_data_bits + additional_data_size);
+ +  }
+ +
+@@ -301,7 +301,7 @@
+ +const DWORD kPipeTimeout = 10000;
+ +const DWORD kMaxMessageLength = 32 * 1024;
+ +
+-+std::unique_ptr<std::vector<const uint8_t>> g_ack_data;
+++std::unique_ptr<std::vector<uint8_t>> g_ack_data;
+ +base::OneShotTimer g_ack_timer;
+ +HANDLE g_write_ack_pipe;
+ +bool g_write_ack_callback_called = false;
+@@ -314,7 +314,7 @@
+                        base::CommandLine* parsed_command_line,
+ -                      base::FilePath* current_directory) {
+ +                      base::FilePath* current_directory,
+-+                      std::vector<const uint8_t>* parsed_additional_data) {
+++                      std::vector<uint8_t>* parsed_additional_data) {
+    // We should have enough room for the shortest command (min_message_size)
+    // and also be a multiple of wchar_t bytes. The shortest command
+ -  // possible is L"START\0\0" (empty current directory and command line).
+@@ -355,7 +355,7 @@
+ +        msg.substr(fourth_null + 1, fifth_null - fourth_null);
+ +    const uint8_t* additional_data_bytes =
+ +        reinterpret_cast<const uint8_t*>(additional_data.c_str());
+-+    *parsed_additional_data = std::vector<const uint8_t>(additional_data_bytes,
+++    *parsed_additional_data = std::vector<uint8_t>(additional_data_bytes,
+ +        additional_data_bytes + additional_data_length);
+ +
+      return true;
+@@ -365,7 +365,7 @@
+  
+ +void StoreAck(const base::span<const uint8_t>* ack_data) {
+ +  if (ack_data) {
+-+    g_ack_data = std::make_unique<std::vector<const uint8_t>>(ack_data->begin(),
+++    g_ack_data = std::make_unique<std::vector<uint8_t>>(ack_data->begin(),
+ +                                                              ack_data->end());
+ +  } else {
+ +    g_ack_data = nullptr;
+@@ -414,7 +414,7 @@
+    base::CommandLine parsed_command_line(base::CommandLine::NO_PROGRAM);
+    base::FilePath current_directory;
+ -  if (!ParseCommandLine(cds, &parsed_command_line, &current_directory)) {
+-+  std::vector<const uint8_t> additional_data;
+++  std::vector<uint8_t> additional_data;
+ +  if (!ParseCommandLine(cds, &parsed_command_line, &current_directory,
+ +                        &additional_data)) {
+      *result = TRUE;
+--- a/shell/browser/api/electron_api_app.cc
++++ b/shell/browser/api/electron_api_app.cc
+@@ -519,12 +519,12 @@
+     const base::RepeatingCallback<
+         void(const base::CommandLine& command_line,
+              const base::FilePath& current_directory,
+-             const std::vector<const uint8_t> additional_data,
++             const std::vector<uint8_t> additional_data,
+              const ProcessSingleton::NotificationAckCallback& ack_callback)>&
+         callback,
+     const base::CommandLine& cmd,
+     const base::FilePath& cwd,
+-    const std::vector<const uint8_t> additional_data,
++    const std::vector<uint8_t> additional_data,
+     const ProcessSingleton::NotificationAckCallback& ack_callback) {
+   // Make sure the callback is called after app gets ready.
+   if (Browser::Get()->is_ready()) {
+@@ -1118,7 +1118,7 @@
+ void App::OnSecondInstance(
+     const base::CommandLine& cmd,
+     const base::FilePath& cwd,
+-    const std::vector<const uint8_t> additional_data,
++    const std::vector<uint8_t> additional_data,
+     const ProcessSingleton::NotificationAckCallback& ack_callback) {
+   v8::Isolate* isolate = JavascriptEnvironment::GetIsolate();
+   v8::Locker locker(isolate);
+--- a/shell/browser/api/electron_api_app.h
++++ b/shell/browser/api/electron_api_app.h
+@@ -197,7 +197,7 @@
+   void OnSecondInstance(
+       const base::CommandLine& cmd,
+       const base::FilePath& cwd,
+-      const std::vector<const uint8_t> additional_data,
++      const std::vector<uint8_t> additional_data,
+       const ProcessSingleton::NotificationAckCallback& ack_callback);
+   bool HasSingleInstanceLock() const;
+   bool RequestSingleInstanceLock(gin::Arguments* args);

Added: electron18/trunk/use-system-libraries-in-node.patch
===================================================================
--- electron18/trunk/use-system-libraries-in-node.patch	                        (rev 0)
+++ electron18/trunk/use-system-libraries-in-node.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,53 @@
+--- a/third_party/electron_node/BUILD.gn
++++ b/third_party/electron_node/BUILD.gn
+@@ -42,6 +42,18 @@
+   node_module_version = ""
+ }
+ 
++if (is_linux) {
++  import("//build/config/linux/pkg_config.gni")
++
++  pkg_config("cares") {
++    packages = [ "libcares" ]
++  }
++
++  pkg_config("nghttp2") {
++    packages = [ "libnghttp2" ]
++  }
++}
++
+ assert(!node_use_dtrace, "node_use_dtrace not supported in GN")
+ assert(!node_use_etw, "node_use_etw not supported in GN")
+ 
+@@ -182,11 +194,9 @@
+ component("node_lib") {
+   deps = [
+     ":node_js2c",
+-    "deps/cares",
+     "deps/histogram",
+     "deps/googletest:gtest",
+     "deps/llhttp",
+-    "deps/nghttp2",
+     "deps/uvwasi",
+     "//third_party/zlib",
+     "//third_party/brotli:dec",
+@@ -202,6 +212,19 @@
+   public_configs = [ ":node_lib_config" ]
+   include_dirs = [ "src" ]
+   libs = []
++  if (is_linux) {
++    configs += [
++      ":cares",
++      ":nghttp2",
++    ]
++    libs += [ "http_parser" ]
++  } else {
++    deps += [
++      "deps/cares",
++      "deps/http_parser",
++      "deps/nghttp2",
++    ]
++  }
+   frameworks = []
+   cflags_cc = [
+     "-Wno-deprecated-declarations",

Added: electron18/trunk/webcodecs-stop-using-AudioOpusEncoder.patch
===================================================================
--- electron18/trunk/webcodecs-stop-using-AudioOpusEncoder.patch	                        (rev 0)
+++ electron18/trunk/webcodecs-stop-using-AudioOpusEncoder.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,49 @@
+From 3bd46cb9a51773f103ef52b39d6407740eb0d60a Mon Sep 17 00:00:00 2001
+From: Eugene Zemtsov <eugene at chromium.org>
+Date: Thu, 24 Feb 2022 23:17:20 +0000
+Subject: [PATCH] webcodecs: Stop using AudioOpusEncoder as backed for mojo
+ audio encoder
+
+AudioOpusEncoder was only used here for testing. Let's not let it get
+comfortable. We'll use MF AAC encoder here when we have it. (Soon...)
+
+Bug: 1259883
+Change-Id: Ia1819395c8c8fd6d403d4b8558c12f9a1bf7e761
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3489449
+Commit-Queue: Eugene Zemtsov <eugene at chromium.org>
+Auto-Submit: Eugene Zemtsov <eugene at chromium.org>
+Reviewed-by: Dale Curtis <dalecurtis at chromium.org>
+Commit-Queue: Dale Curtis <dalecurtis at chromium.org>
+Cr-Commit-Position: refs/heads/main@{#974895}
+---
+ media/mojo/services/gpu_mojo_media_client.cc | 10 +---------
+ 1 file changed, 1 insertion(+), 9 deletions(-)
+
+diff --git a/media/mojo/services/gpu_mojo_media_client.cc b/media/mojo/services/gpu_mojo_media_client.cc
+index 8f83a4d6cf6..40cdaff8d3a 100644
+--- a/media/mojo/services/gpu_mojo_media_client.cc
++++ b/media/mojo/services/gpu_mojo_media_client.cc
+@@ -13,7 +13,6 @@
+ #include "build/chromeos_buildflags.h"
+ #include "gpu/ipc/service/gpu_channel.h"
+ #include "media/audio/audio_features.h"
+-#include "media/audio/audio_opus_encoder.h"
+ #include "media/base/audio_decoder.h"
+ #include "media/base/cdm_factory.h"
+ #include "media/base/media_switches.h"
+@@ -119,14 +118,7 @@ std::unique_ptr<AudioEncoder> GpuMojoMediaClient::CreateAudioEncoder(
+     scoped_refptr<base::SequencedTaskRunner> task_runner) {
+   if (!base::FeatureList::IsEnabled(features::kPlatformAudioEncoder))
+     return nullptr;
+-  // TODO(crbug.com/1259883) Right now Opus encoder is all we have, later on
+-  // we'll create a real platform encoder here.
+-  auto opus_encoder = std::make_unique<AudioOpusEncoder>();
+-  auto encoding_runner = base::ThreadPool::CreateSequencedTaskRunner(
+-      {base::TaskPriority::USER_BLOCKING});
+-  return std::make_unique<OffloadingAudioEncoder>(std::move(opus_encoder),
+-                                                  std::move(encoding_runner),
+-                                                  std::move(task_runner));
++  return nullptr;
+ }
+ 
+ VideoDecoderType GpuMojoMediaClient::GetDecoderImplementationType() {

Added: electron18/trunk/webrtc-check-existence-of-cursor-metadata.patch
===================================================================
--- electron18/trunk/webrtc-check-existence-of-cursor-metadata.patch	                        (rev 0)
+++ electron18/trunk/webrtc-check-existence-of-cursor-metadata.patch	2022-07-06 12:26:55 UTC (rev 1246712)
@@ -0,0 +1,31 @@
+From c2cd814cdd8cbf8dda6ccec2266327a5321fbde8 Mon Sep 17 00:00:00 2001
+From: Jan Grulich <grulja at gmail.com>
+Date: Tue, 15 Mar 2022 14:31:55 +0100
+Subject: [PATCH] PipeWire capturer: check existence of cursor metadata
+
+Check whether there are any cursor metadata before we try to validate
+and use them, otherwise we might crash on this.
+
+Bug: webrtc:13429
+Change-Id: I365da59a189b6b974cebafc94fec49d5b942efae
+Reviewed-on: https://webrtc-review.googlesource.com/c/src/+/255601
+Reviewed-by: Alexander Cooper <alcooper at chromium.org>
+Commit-Queue: Alexander Cooper <alcooper at chromium.org>
+Cr-Commit-Position: refs/heads/main@{#36240}
+---
+ .../desktop_capture/linux/wayland/shared_screencast_stream.cc   | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/modules/desktop_capture/linux/wayland/shared_screencast_stream.cc b/modules/desktop_capture/linux/wayland/shared_screencast_stream.cc
+index a8c86e26..9e81df4c 100644
+--- a/modules/desktop_capture/linux/wayland/shared_screencast_stream.cc
++++ b/modules/desktop_capture/linux/wayland/shared_screencast_stream.cc
+@@ -650,7 +650,7 @@ void SharedScreenCastStreamPrivate::ProcessBuffer(pw_buffer* buffer) {
+     const struct spa_meta_cursor* cursor =
+         static_cast<struct spa_meta_cursor*>(spa_buffer_find_meta_data(
+             spa_buffer, SPA_META_Cursor, sizeof(*cursor)));
+-    if (spa_meta_cursor_is_valid(cursor)) {
++    if (cursor && spa_meta_cursor_is_valid(cursor)) {
+       struct spa_meta_bitmap* bitmap = nullptr;
+ 
+       if (cursor->bitmap_offset)



More information about the arch-commits mailing list